'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.default=void 0;var _extends2=require('babel-runtime/helpers/extends'),_extends3=_interopRequireDefault(_extends2),_regenerator=require('babel-runtime/regenerator'),_regenerator2=_interopRequireDefault(_regenerator),_asyncToGenerator2=require('babel-runtime/helpers/asyncToGenerator'),_asyncToGenerator3=_interopRequireDefault(_asyncToGenerator2),_classCallCheck2=require('babel-runtime/helpers/classCallCheck'),_classCallCheck3=_interopRequireDefault(_classCallCheck2),_createClass2=require('babel-runtime/helpers/createClass'),_createClass3=_interopRequireDefault(_createClass2),_mobx=require('mobx'),_react=require('react'),_react2=_interopRequireDefault(_react),_jss=require('react-jss/lib/jss'),_server=require('react-universal-component/server'),_PWA=require('./PWA'),_PWA2=_interopRequireDefault(_PWA),_createMemoryHistory=require('history/createMemoryHistory'),_createMemoryHistory2=_interopRequireDefault(_createMemoryHistory),_reactHelmet=require('react-helmet'),_sanitizeAmpHtml=require('./amp/sanitizeAmpHtml'),_sanitizeAmpHtml2=_interopRequireDefault(_sanitizeAmpHtml),_renderers=require('./renderers'),_Response=require('./router/Response'),_Response2=_interopRequireDefault(_Response),_Track=require('./Track'),_createRequest=require('./platform/createRequest'),_createRequest2=_interopRequireDefault(_createRequest),_reactStorefrontStats=require('react-storefront-stats'),_reactStorefrontStats2=_interopRequireDefault(_reactStorefrontStats);function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}(0,_mobx.configure)({isolateGlobalState:!0});var Server=function(){/**
   * @param {Object} config
   * @param {Object} config.theme A material-UI theme
   * @param {Class} config.model The model class for the root of the state tree
   * @param {React.Component} config.App The root app component
   * @param {Router} config.router An instance of moov_router's Router class
   * @param {Boolean} [config.deferScripts=true] Adds the defer attribute to all script tags to speed up initial page render. Defaults to true.
   */function a(b){var c=this,d=b.theme,e=b.model,f=b.App,g=b.router,h=b.deferScripts;(0,_classCallCheck3.default)(this,a),this.serve=(0,_asyncToGenerator3.default)(/*#__PURE__*/_regenerator2.default.mark(function a(){var b,d,e;return _regenerator2.default.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:return console.error=console.error||console.log,console.warn=console.warn||console.log,b=(0,_createRequest2.default)(),d=new _Response2.default(b),a.prev=4,d.set('x-rsf-track-cache-hit','true'),a.next=8,c.router.runAll(b,d);case 8:if(e=a.sent,e.proxyUpstream||d.sent){a.next=12;break}return a.next=12,c.renderPWA({request:b,response:d,state:e});case 12:a.next=18;break;case 14:return a.prev=14,a.t0=a['catch'](4),a.next=18,c.renderError(a.t0,b,d);case 18:case'end':return a.stop();}},a,c,[[4,14]])})),console.error=console.warn=console.log,Object.assign(this,{theme:d,model:e,App:f,router:g,deferScripts:void 0===h||h})}/**
   * Handles an isomorphic request by serving json, html, or amp content based on the URL.
   */return(0,_createClass3.default)(a,[{key:'setContentType',/**
   * Sets the content type to application/json for json URLs, text/html for all others
   * @param {Object} request 
   * @param {Response} response 
   */value:function c(a,b){null==b.get('content-type')&&(a.pathname.endsWith('.json')?b.set('content-type','application/json'):b.set('content-type','text/html'))}/**
   * Renders either a JSON or HTML response for the given state based on the path suffix.
   * @param {Object} options
   * @param {Object} options.request The current request object
   * @param {Response} options.response The current response object
   * @param {Object} options.state The root react element
   * @return The html for app
   */},{key:'renderPWA',value:function(){var a=(0,_asyncToGenerator3.default)(/*#__PURE__*/_regenerator2.default.mark(function a(b){var c,d,e,f,g,h,i,j,k,l,m,n,o,p,q=b.request,r=b.response,s=b.state;return _regenerator2.default.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:if(console.error=console.error||console.log,console.warn=console.warn||console.log,c=q.protocol,d=q.hostname,e=q.port,f=q.pathname,g=q.search,this.setContentType(q,r),!f.endsWith('.json')){a.next=6;break}return a.abrupt('return',r.send(JSON.stringify(s)));case 6:return h=f.endsWith('.amp'),i=this.App,j=this.theme,k=new _jss.SheetsRegistry,l=(0,_createMemoryHistory2.default)({initialEntries:[f+g]}),m=this.model.create((0,_extends3.default)({},s,{amp:h,initialWidth:h?'xs':s.initialWidth,location:(0,_extends3.default)({},l.location,{port:e,protocol:c,hostname:d})})),a.prev=11,a.next=14,(0,_reactStorefrontStats2.default)();case 14:n=a.sent,o=(0,_renderers.renderHtml)({component:_react2.default.createElement(_PWA2.default,null,_react2.default.createElement(i,null)),providers:{app:m,history:l,analytics:{},router:this.router},registry:k,theme:j}),p=_reactHelmet.Helmet.renderStatic(),o='\n        <!DOCTYPE html>\n        <html'+(h?' \u26A1':'')+' '+p.htmlAttributes.toString()+'>\n          <head>\n            '+p.title.toString()+'\n            '+(h?'\n              <style amp-boilerplate>body{-webkit-animation:-amp-start 8s steps(1,end) 0s 1 normal both;-moz-animation:-amp-start 8s steps(1,end) 0s 1 normal both;-ms-animation:-amp-start 8s steps(1,end) 0s 1 normal both;animation:-amp-start 8s steps(1,end) 0s 1 normal both}@-webkit-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@-moz-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@-ms-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@-o-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}</style><noscript><style amp-boilerplate>body{-webkit-animation:none;-moz-animation:none;-ms-animation:none;animation:none}</style></noscript>\n              <style amp-custom id="ssr-css">\n                '+k.toString().replace(/\!important/g,'')+'\n                '+p.style.toString().replace(/<\/?style[^>]*>/g,'')+'\n              </style>\n            ':'\n              <noscript id="jss-insertion-point"></noscript>\n            ')+'\n            '+p.meta.toString()+'\n            '+p.link.toString()+'\n            '+p.script.toString()+'\n            '+(h?'<script async custom-element="amp-analytics" src="https://cdn.ampproject.org/v0/amp-analytics-0.1.js"></script>':'')+'\n          </head>\n          <body'+(h?' class="moov-amp"':'')+' '+p.bodyAttributes.toString()+'>\n            '+(h?(0,_Track.renderAmpAnalyticsTags)():'')+'\n            '+(h?'':(0,_renderers.renderStyle)({registry:k}))+'\n            <noscript>\n              You need to enable JavaScript to run this app.\n            </noscript>\n            <div id="root">'+o+'</div>\n            '+(h?'':'\n              '+(0,_renderers.renderInitialStateScript)({state:m,defer:this.deferScripts})+'\n              '+(0,_renderers.renderScript)({stats:n,chunk:'bootstrap',defer:this.deferScripts})+'\n              '+this.getScripts(n)+'\n              '+(0,_renderers.renderScript)({stats:n,chunk:'main',defer:this.deferScripts})+'\n            ')+'\n          </body>\n        </html>\n      ',h&&(o=(0,_sanitizeAmpHtml2.default)(o)),r.send(o),a.next=27;break;case 22:throw a.prev=22,a.t0=a['catch'](11),_reactHelmet.Helmet.renderStatic(),(0,_Track.renderAmpAnalyticsTags)(),a.t0;case 27:case'end':return a.stop();}},a,this,[[11,22]])}));return function b(){return a.apply(this,arguments)}}()/**
   * Renders an error response, either as JSON or SSR HTML, depending on the suffix
   * on the request path.
   * @param {Error} e 
   * @param {Response} response 
   */},{key:'renderError',value:function d(a,b,c){return c.status(500,'error'),this.renderPWA({request:b,response:c,state:{page:'Error',error:a.message,stack:'production'===process.env.MOOV_ENV?null:a.stack}})}/**
   * Gets the script tags that should added to the document based on the chunks used
   * to render the current request.
   * @param {Object} stats 
   * @return {String[]}
   */},{key:'getScripts',value:function c(a){var b=this;return(0,_server.flushChunkNames)().map(function(c){return(0,_renderers.renderScript)({stats:a,chunk:c,defer:b.deferScripts})}).filter(function(a){return!!a})}}]),a}();exports.default=Server;
//# sourceMappingURL=Server.js.map