'use strict';Object.defineProperty(exports,'__esModule',{value:!0});var _extends2=require('babel-runtime/helpers/extends'),_extends3=_interopRequireDefault(_extends2),_classCallCheck2=require('babel-runtime/helpers/classCallCheck'),_classCallCheck3=_interopRequireDefault(_classCallCheck2),_createClass2=require('babel-runtime/helpers/createClass'),_createClass3=_interopRequireDefault(_createClass2),_possibleConstructorReturn2=require('babel-runtime/helpers/possibleConstructorReturn'),_possibleConstructorReturn3=_interopRequireDefault(_possibleConstructorReturn2),_inherits2=require('babel-runtime/helpers/inherits'),_inherits3=_interopRequireDefault(_inherits2);exports.default=withAmp;var _mobxReact=require('mobx-react'),_react=require('react'),_react2=_interopRequireDefault(_react),_reactHelmet=require('react-helmet');function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}/**
 * An HOC that links the AMP equivalent of the current page by adding the ink rel="amphtml" 
 * tag to the document head. Assign this to all views for which AMP is implemented
 * 
 * Example:
 * 
 *  import React, { Component } from 'react'
 *  import withAmp from 'react-storefront/amp/withAmp'
 * 
 *  @withAmp
 *  export default class Product extends Component {
 *    ...
 *  }
 * 
 * @param {React.Component} WrappedComponent The component to add
 * @return {React.Component}
 */function withAmp(a){var b,c,d=(b=(0,_mobxReact.inject)('app','history'),b(c=(0,_mobxReact.observer)(c=function(b){function c(){return(0,_classCallCheck3.default)(this,c),(0,_possibleConstructorReturn3.default)(this,(c.__proto__||Object.getPrototypeOf(c)).apply(this,arguments))}return(0,_inherits3.default)(c,b),(0,_createClass3.default)(c,[{key:'render',value:function g(){var b=this.props.app.location,c=b.pathname,d=b.search,e=b.hostname,f=this.props.app.amp;return _react2.default.createElement(_react.Fragment,null,!f&&_react2.default.createElement(_reactHelmet.Helmet,{key:'amp'},_react2.default.createElement('link',{rel:'amphtml',href:'https://'+e+c+'.amp'+d})),_react2.default.createElement(a,(0,_extends3.default)({key:'component'},this.props)))}}]),c}(_react.Component))||c)||c);return d}/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
//# sourceMappingURL=withAmp.js.map