'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.configureAnalytics=configureAnalytics,exports.getTargets=getTargets;/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */var _targets=[];/**
 * Configures the PWA to broadcast events to all specified targets.  Once configured, You can call any method on
 * on all targets by calling `analytics.fire(method, ...params)`.  
 * 
 * Example:
 * 
 *  // src/analytics.js
 * 
 *  import { configureAnalytics } from 'react-storefront/analytics'
 *  import GoogleTagManagerTarget from 'react-storefront-analytics/GoogleTagManagerTarget'
 *  import MerkleSearchTarget from 'react-storefront-analytics/MerkleSearchTarget'
 * 
 *  configureAnalytics(
 *    new GoogleTagManagerTarget({ apiKey: 'my_gtm_api_key' }),
 *    new MerkleSearchTarget({ apiKey: 'my_merkle_api_key' })
 *  )
 * 
 * // then, to broadcast an analytics event to all targets:
 * 
 * import analytics from 'react-storefront/analytics'
 * 
 * analytics.fire('someEvent', { foo: 'bar' }) // this will call the 'someEvent(data)' method on all configured targets and pass { foo: 'bar' } as the data argument.
 * 
 * @param {AnalyticsTarget[]} targets An array of targets to notify when analytics events occur
 * @return {AnalyticsProvider}
 */function configureAnalytics(){for(var a=arguments.length,b=Array(a),c=0;c<a;c++)b[c]=arguments[c];_targets=b}function getTargets(){return _targets}function fire(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];var e=!0,f=!1,g=void 0;try{for(var h,i=_targets[Symbol.iterator]();!(e=(h=i.next()).done);e=!0){var j=h.value,k=j[a];k?k.apply(j,c):'string'==typeof a&&console.warn(j.constructor.name+' does not support '+a)}}catch(a){f=!0,g=a}finally{try{!e&&i.return&&i.return()}finally{if(f)throw g}}}/**
 * This module's default export is a single entry point for broadcasting analytics events to all targets configured via `configureAnalytics`.
 * Each target represents a tag manager or other analytics service to which the application should send data.
 * 
 * Example:
 * 
 *  // src/analytics.js
 * 
 *  import { configureAnalytics } from 'react-storefront/analytics'
 *  import GoogleTagManagerTarget from 'react-storefront-analytics/GoogleTagManagerTarget'
 *  import MerkleSearchTarget from 'react-storefront-analytics/MerkleSearchTarget'
 * 
 *  configureAnalytics(
 *    new GoogleTagManagerTarget({ apiKey: 'my_gtm_api_key' }),
 *    new MerkleSearchTarget({ apiKey: 'my_merkle_api_key' })
 *  )
 * 
 */var analytics={fire:fire};'undefined'!=typeof Proxy&&(analytics=new Proxy({fire:fire},{get:function c(a,b){return'fire'===b?fire:fire.bind(null,b)}})),exports.default=analytics;
//# sourceMappingURL=analytics.js.map