'use strict';Object.defineProperty(exports,'__esModule',{value:!0});var _extends2=require('babel-runtime/helpers/extends'),_extends3=_interopRequireDefault(_extends2),_objectWithoutProperties2=require('babel-runtime/helpers/objectWithoutProperties'),_objectWithoutProperties3=_interopRequireDefault(_objectWithoutProperties2);exports.fetchWithCookies=fetchWithCookies,exports.default=fetch,exports.acceptInvalidCerts=acceptInvalidCerts;var _isString=require('lodash/isString'),_isString2=_interopRequireDefault(_isString),_merge=require('lodash/merge'),_merge2=_interopRequireDefault(_merge),_url=require('url'),_url2=_interopRequireDefault(_url),_qs=require('qs'),_qs2=_interopRequireDefault(_qs);function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */function isFormUrlEncoded(a){return a&&0<=a.indexOf('x-www-form-urlencoded')}/**
 * Creates options for a fetch call
 * @param {String} url The URL to fetch
 * @param {Object} options fetch options
 * @param {String} qsOptions Options for serializing the request body using the qs package
 */function createRequestOptions(a){var b=1<arguments.length&&arguments[1]!==void 0?arguments[1]:{},c=arguments[2],d=b.body,e=b.headers,f=e===void 0?{}:e,g=b.method,h=(0,_objectWithoutProperties3.default)(b,['body','headers','method']);d&&(g=g||'POST',!(0,_isString2.default)(d)&&(isFormUrlEncoded(f['content-type'])?d=_qs2.default.stringify(d,c):(d=JSON.stringify(d),f['content-type']='application/json')),f['content-length']=Buffer.byteLength(d));var i=_url2.default.parse(a),j=i.hostname,k=i.port,l=i.path;return(0,_extends3.default)({},h,{method:g,body:d,hostname:j,port:k,path:l,headers:f,rejectUnauthorized:!1,requestCert:!0})}/**
 * The same as fetch, but automatically relays the cookies passed in from the browser to the upstream API.
 * @param {String} url The url to fetch
 * @param {Object} options Options for fetch
 * @param {String} qsOptions Options for serializing the request body using the qs package
 * @return {Promise}
 */function fetchWithCookies(a){var b=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},c=arguments[2],d={};return env.cookie&&!1!==env.shouldSendCookies&&(d.cookie=env.cookie),fetch(a,(0,_merge2.default)(b,{credentials:'include',headers:d}),c)}/**
 * An implementation of the standard fetch API.  See https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API for options
 * 
 * This function is commonly used to fetch json data:
 * 
 *  const data = await fetch('https://jsonplaceholder.typicode.com/todos/1')
 *    .then(res => res.json())
 * 
 * ... or string data:
 * 
 *  const text = await fetch('https://jsonplaceholder.typicode.com/todos/1')
 *    .then(res => res.text())
 *
 * ... but you can also use it to fetch binary data:
 * 
 *  const buffer = await fetch('https://www.w3.org/WAI/ER/tests/xhtml/testfiles/resources/pdf/dummy.pdf')
 *    .then(res => res.arrayBuffer())
 * 
 * @param {String} url 
 * @param {Object} options Options for fetch
 * @param {String} qsOptions Options for serializing the request body using the qs package
 * @return {Promise}
 */function fetch(a,b,c){return new Promise(function(d,e){var f=a.match(/^https/)?global.https:global.http,g=createRequestOptions(a,b,c),h=g.body,i=(0,_objectWithoutProperties3.default)(g,['body']),j=global.Buffer,k=f.request(i,function(a){var b=[];relaySetCookies(a,i.hostname),a.on('data',function(a){return b.push(a)}),a.on('end',function(){b=j.concat(b);var c=200<=a.statusCode&&299>=a.statusCode;if([301,302].includes(a.statusCode)&&a.headers.location){var g={redirect:a.headers.location};return d({status:a.statusCode,ok:!0,headers:a.headers,text:function a(){return Promise.resolve(JSON.stringify(g))},json:function a(){return Promise.resolve(g)}})}var f={status:a.statusCode,ok:c,headers:a.headers,arrayBuffer:function a(){return Promise.resolve(b)},text:function a(){return Promise.resolve(b.toString('utf8'))},json:function a(){return Promise.resolve(JSON.parse(b.toString('utf8')))}};if(!c){var h=new Error(a.statusCode+': '+b.toString('utf8'));return h.response=f,void e(h)}// Recreating simple API similar to Fetch
// https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API
d(f)})});// use native node buffer, not webpack's shim, so it can be passed with response.send() on Moov XDN
// Moov should inject this via the Server component
k.on('error',function(a){e(a)}),h&&k.write(h),k.end()})}/**
 * Adds a set-cookie header to env.MUR_SET_COOKIES so we can relay it to the browser in Response.send
 * This is the mechanism by which we propagate sessions created in MUR requests.
 * @param {Object} request The request object
 * @param {String} domain The request hostname
 */function relaySetCookies(a,b){var c=a.headers['set-cookie'];if(c){var d=env.MUR_SET_COOKIES||{};d[b]=(d[b]||[]).concat(c),fns.export('MUR_SET_COOKIES',d)}}/**
 * Returns headers that will allow fetch to ignore servers that don't have a valid certificate.
 * This can be used to connect to servers that use a self signed certificate but should 
 * not be used in production.
 * 
 * Example usage:
 * 
 *  fetch('https://example.com', {
 *    headers: {
 *      ...acceptInvalidCerts(),
 *      // other headers here
 *    }
 *  })
 * 
 * @return {Object} An object to spread onto fetch headers
 */function acceptInvalidCerts(){return{agent:new https.Agent({rejectUnauthorized:!1})}}
//# sourceMappingURL=fetch.js.map