'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.StaleResponseError=void 0;var _class,_temp2,_classCallCheck2=require('babel-runtime/helpers/classCallCheck'),_classCallCheck3=_interopRequireDefault(_classCallCheck2),_possibleConstructorReturn2=require('babel-runtime/helpers/possibleConstructorReturn'),_possibleConstructorReturn3=_interopRequireDefault(_possibleConstructorReturn2),_inherits2=require('babel-runtime/helpers/inherits'),_inherits3=_interopRequireDefault(_inherits2),_extends2=require('babel-runtime/helpers/extends'),_extends3=_interopRequireDefault(_extends2);exports.fetchLatest=fetchLatest;function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 *//**
 * Creates a fetch function with an internal incrementing request counter that ensures that out of order
 * responses result in a StaleResponseError.
 * 
 * Example usage:
 *  
 *  import { fetchLatest, StaleResponseError } from 'react-storefront/fetch'
 * 
 *  const fetch = fetchLatest()
 * 
 *  try {
 *    const response = await fetch('/some/url')
 *  } catch (e) {
 *    if (!StaleResponseError.is(e)) { 
 *      throw e // just ignore stale responses, rethrow all other errors
 *    }
 *  }
 * 
 * @return {Function}
 */function fetchLatest(a){var b=0,c=void 0,d=function(){return c&&c.abort(),'undefined'==typeof AbortController?{signal:null}:c=new AbortController};return function(c,e){var f=++b,g=d().signal;return a(c,(0,_extends3.default)({},e,{signal:g})).then(function(a){if(f!=b)throw new StaleResponseError;return a}).catch(function(a){// For browsers that support AbortController, ensure that the behavior is the same as browsers that don't - 
// StaleResponseError should be thrown in either case
if('AbortError'===a.name)throw new StaleResponseError;else throw a})}}/**
 * Thrown when an out of order response is received
 */var StaleResponseError=exports.StaleResponseError=(_temp2=_class=function(a){function b(){var a,c,d,e;(0,_classCallCheck3.default)(this,b);for(var f=arguments.length,g=Array(f),h=0;h<f;h++)g[h]=arguments[h];return e=(c=(d=(0,_possibleConstructorReturn3.default)(this,(a=b.__proto__||Object.getPrototypeOf(b)).call.apply(a,[this].concat(g))),d),d.name='StaleResponseError',c),(0,_possibleConstructorReturn3.default)(d,e)}/**
   * Returns true if the specified Error is an instance of StaleResponseError
   */return(0,_inherits3.default)(b,a),b}(Error),_class.is=function(a){return'StaleResponseError'===a.name},_temp2);
//# sourceMappingURL=fetchLatest.js.map