'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.LocationModel=exports.BreadcrumbModel=void 0;var _mobxStateTree=require('mobx-state-tree'),_Menu=require('../Menu'),_NavTabs=require('../NavTabs'),_CategoryModelBase=require('./CategoryModelBase'),_CategoryModelBase2=_interopRequireDefault(_CategoryModelBase),_SubcategoryModelBase=require('./SubcategoryModelBase'),_SubcategoryModelBase2=_interopRequireDefault(_SubcategoryModelBase),_ProductModelBase=require('./ProductModelBase'),_ProductModelBase2=_interopRequireDefault(_ProductModelBase),_UserModelBase=require('./UserModelBase'),_UserModelBase2=_interopRequireDefault(_UserModelBase),_CartModelBase=require('./CartModelBase'),_CartModelBase2=_interopRequireDefault(_CartModelBase),_SearchModelBase=require('./SearchModelBase'),_SearchModelBase2=_interopRequireDefault(_SearchModelBase),_isEqual=require('lodash/isEqual'),_isEqual2=_interopRequireDefault(_isEqual);function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}/**
 * Represents a single breadcrumb
 *//**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */var BreadcrumbModel=exports.BreadcrumbModel=_mobxStateTree.types.model('BreadcrumbModel',{/**
     * The URL to link to
     */url:_mobxStateTree.types.maybe(_mobxStateTree.types.string),/**
     * The text for the link
     */text:_mobxStateTree.types.string,/**
     * An object to be applied to the state tree when the breadcrumb is clicked.  The shape should match your AppModel class.
     */state:_mobxStateTree.types.frozen}),LocationModel=exports.LocationModel=_mobxStateTree.types.model({protocol:'https',hostname:_mobxStateTree.types.maybe(_mobxStateTree.types.string),pathname:_mobxStateTree.types.string,search:_mobxStateTree.types.string,port:'443'}),AppModelBase=_mobxStateTree.types.model('AppModelBase',{amp:!1,initialWidth:'xs',page:_mobxStateTree.types.maybe(_mobxStateTree.types.string),title:_mobxStateTree.types.maybe(_mobxStateTree.types.string),description:_mobxStateTree.types.maybe(_mobxStateTree.types.string),loading:!1,error:_mobxStateTree.types.maybe(_mobxStateTree.types.string),stack:_mobxStateTree.types.maybe(_mobxStateTree.types.string),menu:_mobxStateTree.types.optional(_Menu.MenuModel,{}),tabs:_mobxStateTree.types.maybe(_NavTabs.TabsModel),category:_mobxStateTree.types.maybe(_CategoryModelBase2.default),subcategory:_mobxStateTree.types.maybe(_SubcategoryModelBase2.default),product:_mobxStateTree.types.maybe(_ProductModelBase2.default),loadingProduct:_mobxStateTree.types.maybe(_ProductModelBase2.default),loadingSubcategory:_mobxStateTree.types.maybe(_SubcategoryModelBase2.default),loadingCategory:_mobxStateTree.types.maybe(_CategoryModelBase2.default),user:_mobxStateTree.types.maybe(_UserModelBase2.default),location:_mobxStateTree.types.maybe(LocationModel),search:_mobxStateTree.types.optional(_SearchModelBase2.default,{}),breadcrumbs:_mobxStateTree.types.optional(_mobxStateTree.types.array(BreadcrumbModel),[]),cart:_mobxStateTree.types.optional(_CartModelBase2.default,{})}).views(function(a){return{get canonicalURL(){var b=a.location,c=b.protocol,d=b.hostname,e=b.pathname,f=b.search;return c+'//'+d+e.replace(/\.amp$/,'')+f},get uri(){return a.location.pathname+a.location.search}}}).actions(function(a){return{/**
     * Clears the thumbnail being injected into the product skeleton
     */clearProductThumbnail:function b(){a.productThumbnail=null},/**
     * Applies a patch to the state tree
     * @param {Object} patch The patch to apply
     * @param {String} action "PUSH", "POP", or "REPLACE"
     */applyState:function d(b,c){if('POP'===c)// the user clicked the browser's back button
// ensure that state not corresponding to the URL is retained, for example the user and cart
// ensure that data for other pages is not changed.  This minimizes component reconciliation to boost performance
// apply the page change first so the UI swaps to the previous page immediately
// if we're still loading the current page, we can hide the load mask immediately because we're going back to the previous page
b=a.retainStateOnHistoryPop(b),auditPatchOnPop(a,b),a.page=b.page,a.loading=!1,setImmediate(function(){return a.applyState(b)});else{// all other navigation
var e=a.toJSON();for(var f in b){var g=b[f];(0,_isEqual2.default)(g,e[f])||(a[f]=g)}}},/**
     * Returns the part of the state tree which should not be overwritten
     * when the user goes forward or back.  You can override this action
     * to retain additional branches of the tree.
     */retainStateOnHistoryPop:function b(a){return delete a.cart,delete a.user,delete a.menu,delete a.tabs,a},/**
     * Sets the user model
     * @param {UserModelBase} user 
     */signIn:function c(b){a.user=b},/**
     * Cleares the user model
     */signOut:function b(){a.user=null},/**
     * Restores the user identity
     * @param {UserModelBase} user 
     */setUser:function c(b){a.user=b},/**
     * Displays an error state
     * @param {Error} e 
     */onError:function c(b){a.page='Error',a.error=b.message,a.stack=b.stack}}});/**
 * Removes values from the patch corresponding to existing values in the model that
 * implement forPage and for which forPage does not match the page being set in the patch.
 * 
 * This helps minimize react component reconciliation by ensuring that values corresponding to
 * hidden pages are not changed when navigating back.
 * 
 * @param {AppModelBase} model The app model instance
 * @param {Object} patch The patch to be applied
 */function auditPatchOnPop(a,b){if(b.page)for(var c in b){var d=a[c];d&&d.shouldApplyPatchOnPop&&!d.shouldApplyPatchOnPop(b)&&delete b[c]}}exports.default=AppModelBase;
//# sourceMappingURL=AppModelBase.js.map