'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.ResultsGroupModel=exports.ResultsModel=void 0;var _regenerator=require('babel-runtime/regenerator'),_regenerator2=_interopRequireDefault(_regenerator),_asyncToGenerator2=require('babel-runtime/helpers/asyncToGenerator'),_asyncToGenerator3=_interopRequireDefault(_asyncToGenerator2),_fetch=require('fetch'),_fetch2=_interopRequireDefault(_fetch),_debounce=require('lodash/debounce'),_debounce2=_interopRequireDefault(_debounce),_mobxStateTree=require('mobx-state-tree'),_fetchLatest=require('../fetchLatest');function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}// Ensures that responses are returned in order and that the previous request is canceled when a new request is sent.
/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */var fetchSearchResults=(0,_fetchLatest.fetchLatest)(_fetch2.default),ResultsModel=exports.ResultsModel=_mobxStateTree.types.model('ResultsModel',{/**
     * The link text
     */text:_mobxStateTree.types.string,/**
     * The link's target url
     */url:_mobxStateTree.types.string,/**
     * A url for a thumbnail image
     */thumbnail:_mobxStateTree.types.maybe(_mobxStateTree.types.string),/**
     * The thumbnail height
     */thumbnailHeight:120,/**
     * The thumbnail width
     */thumbnailWidth:120}),ResultsGroupModel=exports.ResultsGroupModel=_mobxStateTree.types.model('ResultsGroupModel',{/**
     * The caption to display at the top of the group
     */caption:_mobxStateTree.types.string,/**
     * The list of links to display
     */results:_mobxStateTree.types.optional(_mobxStateTree.types.array(ResultsModel),[])}).views(function(a){return{get thumbnails(){return a.results.some(function(a){return null!=a.thumbnail})}}}),SearchModelBase=_mobxStateTree.types.model('SearchModelBase',{/**
     * The search phrase entered by the user
     */text:'',/**
     * The resulting groups
     */groups:_mobxStateTree.types.optional(_mobxStateTree.types.array(ResultsGroupModel),[]),/**
     * True to show the loading sprinner
     */loading:!1,/**
     * True to show the search popup
     */show:!1}).actions(function(a){return{/**
     * Set `true` to show the search popup, `false` to hide.
     * @param {Boolean} show 
     */toggle:function c(b){a.show=b},/**
     * Update the search text
     * @param {String} text 
     */setText:function c(b){a.text=b,a.loading=0<a.text.trim().length,a.submit(b)},/**
     * Set `true` to show the loading spinner, `false` to hide.
     * @param {Boolean} state 
     */setLoading:function c(b){a.loading=b},/**
     * Submit the search for the given keyword.  Fetched calls are automatically debounced and serialized so that
     * results are received in order.
     * @param {String} keyword
     */submit:(0,_debounce2.default)(function(){var b=(0,_asyncToGenerator3.default)(/*#__PURE__*/_regenerator2.default.mark(function b(c){var d;return _regenerator2.default.wrap(function(b){for(;;)switch(b.prev=b.next){case 0:if(c){b.next=2;break}return b.abrupt('return');case 2:return b.prev=2,b.next=5,fetchSearchResults('/search/suggest.json?q='+encodeURIComponent(c)).then(function(a){return a.json()});case 5:d=b.sent,a.setGroups(d.search.groups),a.setLoading(!1),b.next=15;break;case 10:if(b.prev=10,b.t0=b['catch'](2),_fetchLatest.StaleResponseError.is(b.t0)){b.next=15;break}throw a.setLoading(!1),b.t0;case 15:case'end':return b.stop();}},b,void 0,[[2,10]])}));return function(){return b.apply(this,arguments)}}(),500),/**
     * Set the groups to be displayed
     * @param {ResultsGroupModel[]} groups 
     */setGroups:function c(b){a.groups=b}}});/**
 * Represents an individual link within a group
 *//**
 * Represents a group of links withing the search results
 *//**
 * The base model for site-wide searches.
 */exports.default=SearchModelBase;
//# sourceMappingURL=SearchModelBase.js.map