'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.SortBase=exports.FacetGroupModelBase=exports.FacetModelBase=exports.LAYOUT_GRID=exports.LAYOUT_LIST=void 0;var _toConsumableArray2=require('babel-runtime/helpers/toConsumableArray'),_toConsumableArray3=_interopRequireDefault(_toConsumableArray2),_asyncToGenerator2=require('babel-runtime/helpers/asyncToGenerator'),_asyncToGenerator3=_interopRequireDefault(_asyncToGenerator2),_regenerator=require('babel-runtime/regenerator'),_regenerator2=_interopRequireDefault(_regenerator),_mobxStateTree=require('mobx-state-tree'),_fetch=require('fetch'),_fetch2=_interopRequireDefault(_fetch),_ProductModelBase=require('./ProductModelBase'),_ProductModelBase2=_interopRequireDefault(_ProductModelBase);function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}var LAYOUT_LIST=exports.LAYOUT_LIST='LAYOUT_LIST',LAYOUT_GRID=exports.LAYOUT_GRID='LAYOUT_GRID',FacetModelBase=exports.FacetModelBase=_mobxStateTree.types.model('FacetModelBase',{/**
   * The value sent to the API when filtering
   */code:_mobxStateTree.types.maybe(_mobxStateTree.types.string),/**
   * The text displayed in the UI
   */name:_mobxStateTree.types.identifier(_mobxStateTree.types.string),/**
   * The number of items having the value
   */matches:_mobxStateTree.types.maybe(_mobxStateTree.types.number)}),FacetGroupModelBase=exports.FacetGroupModelBase=_mobxStateTree.types.model('FacetGroupModelBase',{/**
   * The text displayed in the UI
   */name:_mobxStateTree.types.identifier(_mobxStateTree.types.string),/**
   * The facets in the group
   */facets:_mobxStateTree.types.optional(_mobxStateTree.types.array(FacetModelBase),[])}),SortBase=exports.SortBase=_mobxStateTree.types.model('SortBase',{/**
   * The code sent to the API when sorting
   */code:_mobxStateTree.types.identifier(_mobxStateTree.types.string),/**
   * The text displayed in the UI
   */name:_mobxStateTree.types.maybe(_mobxStateTree.types.string)});/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 *//**
 * A search facet that can be applied as a filter
 *//**
 * A grouping of facets
 *//**
 * A value by which results can be sorted
 *//**
 * A base class for search results and subcategories that supports filtering and sorting
 */exports.default=_mobxStateTree.types.model('SearchResultsModelBase',{/**
     * The codes of the currently applied filters
     */filters:_mobxStateTree.types.optional(_mobxStateTree.types.array(_mobxStateTree.types.string),[]),/**
     * Automatically set to true when the user has changed a filter.  This causes
     * the filter dialog footer to be displayed.
     */filtersChanged:!1,/**
     * Filters that can be selected
     */facetGroups:_mobxStateTree.types.optional(_mobxStateTree.types.array(FacetGroupModelBase),[]),/**
     * The code for the currently selected sort option
     */sort:_mobxStateTree.types.maybe(_mobxStateTree.types.string),/**
     * Sort options that can be selected
     */sortOptions:_mobxStateTree.types.optional(_mobxStateTree.types.array(SortBase),[]),/**
     * The total number of matching items. You can either specify numberOfPages or total to determine
     * when to display the Show More Button.  Only one is required.
     */total:_mobxStateTree.types.maybe(_mobxStateTree.types.number),/**
     * The total number of pages.  You can either specify numberOfPages or total to determine
     * when to display the Show More Button.  Only one is required.
     */numberOfPages:_mobxStateTree.types.maybe(_mobxStateTree.types.number),/**
     * The matching items
     */items:_mobxStateTree.types.optional(_mobxStateTree.types.array(_ProductModelBase2.default),[]),/**
     * Set to true when fetching data from the server in response to a filter or sort change.
     */loading:!1,/**
     * Set to true when loading more items from the server is in progress.
     */loadingMore:!1,/**
     * The current page being displayed
     */page:0,/**
     * The maximum number of records per page
     */pageSize:10,/**
     * Sets the layout style on the view.  Can be LAYOUT_LIST or LAYOUT_GRID.  Defaults to LAYOUT_GRID.
     */layout:_mobxStateTree.types.optional(_mobxStateTree.types.enumeration('Layout',[LAYOUT_LIST,LAYOUT_GRID]),LAYOUT_GRID)}).views(function(a){return{get hasMoreItems(){return null==a.numberOfPages?null!=a.total&&a.total>a.items.length:a.numberOfPages-1>a.page}}}).actions(function(a){return{/**
     * Removes all filters.
     */clearAllFilters:function b(){a.filters.clear(),a.filtersChanged=!0},/**
     * Sets the filtersChanged field
     * @param {Boolean} changed
     */setFiltersChanged:function c(b){a.filtersChanged=b},/**
     * Refreshes the search based on the current filters and sort and resets the page to 0.
     */refresh:(0,_mobxStateTree.flow)(/*#__PURE__*/_regenerator2.default.mark(function b(){return _regenerator2.default.wrap(function(b){for(;;)switch(b.prev=b.next){case 0:return a.filtersChanged=!1,a.loading=!0,b.next=4,a.showPage(0);case 4:a.loading=!1;case 5:case'end':return b.stop();}},b,this)})),/**
     * Toggles a facet on or off.
     * @param {FacetModelBase} facet
     */toggleFilter:function e(b){var c=b.code,d=a.filters.indexOf(c);-1===d?a.filters.push(c):a.filters.splice(d,1),a.filtersChanged=!0},showPage:function(){var b=(0,_asyncToGenerator3.default)(/*#__PURE__*/_regenerator2.default.mark(function b(c){var d,e,f,g;return _regenerator2.default.wrap(function(b){for(;;)switch(b.prev=b.next){case 0:return a.page=c,d=window.location,e=d.pathname,f=d.search,f+=(f.length?'&':'?')+'page='+a.page,b.prev=3,a.loadingMore=0<c,b.next=7,(0,_fetch2.default)(a.getShowMoreURL(e+'.json'+f)).then(function(a){return a.json()});case 7:g=b.sent,(0,_mobxStateTree.isAlive)(a)&&(a.addItems(g.items),a.setTotal(g.total));case 9:return b.prev=9,(0,_mobxStateTree.isAlive)(a)&&a.endLoadingMore(),b.finish(9);case 12:case'end':return b.stop();}},b,this,[[3,,9,12]])}));return function a(){return b.apply(this,arguments)}}(),/**
     * Fetches the next page from the server.
     */showMore:function(){var b=(0,_asyncToGenerator3.default)(/*#__PURE__*/_regenerator2.default.mark(function b(){return _regenerator2.default.wrap(function(b){for(;;)switch(b.prev=b.next){case 0:if(a.loading){b.next=3;break}return b.next=3,a.showPage(a.page+1);case 3:case'end':return b.stop();}},b,this)}));return function a(){return b.apply(this,arguments)}}(),getShowMoreURL:function b(a){return a},/**
     * Hides the loading more spinner.
     */endLoadingMore:function b(){a.loadingMore=!1},/**
     * Adds more items to the results
     * @param {Array} items
     */addItems:function c(b){0===a.page&&(a.items=[]),Array.isArray(b)&&(a.items=[].concat((0,_toConsumableArray3.default)(a.items),(0,_toConsumableArray3.default)(b))),a.endLoadingMore()},/**
     * Sets the total number of matching records
     * @param {Integer} total 
     */setTotal:function c(b){a.total=b},/**
     * Toggles the layout
     * @param {String} layout LAYOUT_LIST or LAYOUT_GRID
     */switchLayout:function c(b){a.layout=b},/**
     * Sets the selected sort option
     */setSort:function c(b){a.sort=b.code}}});
//# sourceMappingURL=SearchResultsModelBase.js.map