'use strict';Object.defineProperty(exports,'__esModule',{value:!0});var _extends2=require('babel-runtime/helpers/extends'),_extends3=_interopRequireDefault(_extends2),_slicedToArray2=require('babel-runtime/helpers/slicedToArray'),_slicedToArray3=_interopRequireDefault(_slicedToArray2);exports.getJS=getJS,exports.renderHtml=renderHtml,exports.renderInitialStateScript=renderInitialStateScript,exports.renderScript=renderScript,exports.renderStyle=renderStyle,exports.render=render,exports.hydrate=hydrate;var _react=require('react'),_react2=_interopRequireDefault(_react),_reactDom=require('react-dom'),_reactDom2=_interopRequireDefault(_reactDom),_server=require('react-dom/server'),_mobxReact=require('mobx-react'),_jss=require('react-jss/lib/jss'),_JssProvider=require('react-jss/lib/JssProvider'),_JssProvider2=_interopRequireDefault(_JssProvider),_jss2=require('jss'),_styles=require('@material-ui/core/styles'),_jssNested=require('jss-nested'),_jssNested2=_interopRequireDefault(_jssNested),_createGenerateClassName=require('./utils/createGenerateClassName'),_createGenerateClassName2=_interopRequireDefault(_createGenerateClassName);function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}// Escape <\ in a closing script tag to avoid untimely script closing
var getSanitizedModelJson=function(a){return JSON.stringify(a.toJSON()).replace(/<\/script/gi,'<\\/script')};/**
 * Get javascript asset filename by chunk name 
 * @param  {Object} stats Webpack generated stats
 * @param  {String} chunk Chunk name
 * @return {String}       Asset filename
 *//**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */function getJS(a,b){var c=a.assetsByChunkName[b];return c?Array.isArray(c)?c.find(function(a){return a.endsWith('.js')}):c:null}/**
 * Render HTML of given component
 * @param  {React.Component} options.component Component to be rendered
 * @param  {Object} options.providers          Data providers
 * @param  {Object} options.registry           JSS Sheets Registry
 * @param  {Object} options.theme              MUI Theme
 * @param  {Object} options.cssPrefix          A prefix to apply to css classes
 * @return {String}                            HTML
 */function renderHtml(a){var b=a.component,c=a.providers,d=a.registry,e=a.theme,f=a.cssPrefix,g=f===void 0?'jss':f;return(0,_server.renderToString)(_react2.default.createElement(_mobxReact.Provider,c,_react2.default.createElement(_JssProvider2.default,{classNamePrefix:g,registry:d,generateClassName:(0,_createGenerateClassName2.default)()},_react2.default.createElement(_styles.MuiThemeProvider,{theme:e,sheetsManager:new Map},b))))}/**
 * Renders initial state for client side hydration
 * @param  {Object} options.state                 Model instance
 * @param  {Boolean} options.defer                Should defer execution
 * @param  {String} options.initialStateProperty  Property name on window object
 * @return {String}                               Script HTML
 */function renderInitialStateScript(a){var b=a.state,c=a.defer,d=a.initialStateProperty,e=d===void 0?'initialState':d;return'<script type="text/javascript" '+(c?'defer':'')+'>\n\t\twindow.moov = { apiVersion: '+JSON.stringify(__webpack_hash__)+' }\n\t\twindow.'+e+'=Object.freeze('+getSanitizedModelJson(b)+')\n\t</script>'}/**
 * Renders script for a specified chunk
 * @param  {Object} options.stats   Webpack generated stats
 * @param  {String} options.chunk   Chunk name
 * @param  {Boolean} options.defer  Should defer execution
 * @return {String}                 Script HTML
 */function renderScript(a){var b=a.stats,c=a.chunk,d=a.defer,e=getJS(b,c);if(!e)return'';var f=process.env.ASSET_PATH_BASE||'';return'<script type="text/javascript" '+(d?'defer':'')+' src="'+f+'/pwa/'+e+'"></script>'}/**
 * Renders extracted CSS from Sheets Registry
 * @param  {Object} options.registry  JSS Sheets Registry
 * @param  {String} options.id        ID for style tag
 * @return {String}                   Style HTML
 */function renderStyle(a){var b=a.registry,c=a.id,d=c===void 0?'ssr-css':c;return'<style id="'+d+'">'+b.toString()+'</style>'}/**
 * Helper for extracting location object from Adapt environment
 * @param  {Object} env Adapt Environment
 * @return {Object}     Location Object
 */function getLocation(a){var b=a.path.split('?'),c=(0,_slicedToArray3.default)(b,2),d=c[0],e=c[1];return{protocol:a.secure?'https':'http',hostname:a.host,pathname:d,search:e||''}}/**
 * Renders a component on the server.
 * @param  {React.Component} options.component    Component to be rendered
 * @param  {Object} options.state                 Model instance
 * @param  {Object} options.theme                 MUI Theme
 * @param  {Object} options.stats                 Webpack generated stats
 * @param  {String} options.clientChunk           Chunk name for hydration script
 * @param  {String} options.initialStateProperty  Optional window property name for initial state
 * @param  {Boolean} options.injectAssets					Defaults to true.  Set this to false to prevent scripts and css from automatically being injected into the document.
 * @param  {String} options.cssPrefix 						A prefix to apply to css class names
 * @return {Object}                               Components for SSR
 */function render(a){var b=a.component,c=a.state,d=a.theme,e=a.stats,f=a.clientChunk,g=a.initialStateProperty,h=a.injectAssets,i=a.cssPrefix,j=new _jss.SheetsRegistry;c.applyState({location:getLocation(env)},'REPLACE');var k=renderHtml({component:b,providers:{app:c},registry:j,theme:d,cssPrefix:i}),l={html:k,style:renderStyle({registry:j}),initialStateScript:renderInitialStateScript({state:c,defer:!1,initialStateProperty:g}),bootstrapScript:renderScript({stats:e,chunk:'bootstrap'}),componentScript:renderScript({stats:e,chunk:f})};return(void 0===h||h)&&($head.append(l.style),$body.append(l.initialStateScript),$body.append(l.bootstrapScript),$body.append(l.componentScript)),l}/**
 * Hydrates React component
 * @param  {React.Component} options.component    Component to be rendered
 * @param  {Model} options.model                  MobX Model
 * @param  {Object} options.theme                 MUI Theme
 * @param  {String} options.target                Selector for rendering target 
 * @param  {String} options.providerProps         Props to add the to <Provider/> element
 * @param  {String} options.initialStateProperty  Optional window property name for initial state
 * @return {Object} The app state
 */function hydrate(a){var b=a.component,c=a.model,d=a.theme,e=a.target,f=a.providerProps,g=void 0===f?{}:f,h=a.initialStateProperty,i=void 0===h?'initialState':h,j=a.cssPrefix,k=void 0===j?'jss':j,l=(0,_createGenerateClassName2.default)(),m=c.create(window[i]||{}),n=(0,_jss2.create)((0,_styles.jssPreset)(),(0,_jssNested2.default)());// skip jss insertion if we are hydrating SSR cached by the service worker because it has already been mounted
if(Object.assign(window.moov,{state:m,timing:{}},g),!document.body.hasAttribute('data-jss-inserted')){var o=document.createComment('jss-insertion-point');document.head.insertBefore(o,document.head.firstChild),n.options.insertionPoint='jss-insertion-point',document.body.setAttribute('data-jss-inserted','on')}return _reactDom2.default.hydrate(_react2.default.createElement(_mobxReact.Provider,(0,_extends3.default)({app:m},g),_react2.default.createElement(_JssProvider2.default,{classNamePrefix:k,jss:n,generateClassName:l},_react2.default.createElement(_styles.MuiThemeProvider,{theme:d},b))),e,removeSSRStyles),m}/**
 * Removes the style tag rendered on the server so that components are styled correctly 
 * after hydration.
 */function removeSSRStyles(){var a=document.getElementById('ssr-css');a&&a.parentNode&&a.parentNode.removeChild(a)}
//# sourceMappingURL=renderers.js.map