'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.default=exports.NO_CACHE_HEADER=void 0;var _classCallCheck2=require('babel-runtime/helpers/classCallCheck'),_classCallCheck3=_interopRequireDefault(_classCallCheck2),_createClass2=require('babel-runtime/helpers/createClass'),_createClass3=_interopRequireDefault(_createClass2),_cookie=require('cookie'),_cookie2=_interopRequireDefault(_cookie);function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 *//**
 * The standard cache-control header value sent for all resources that are not to be cached.
 */var NO_CACHE_HEADER=exports.NO_CACHE_HEADER='no-cache',Response=function(){/**
   * The default cache settings for browser and server cache.  Override this by calling cacheOnServer
   *//**
   * The text/html mime type
   *//**
   * This will be flipped to `true` when send is called.
   *//**
   * The setting for service-worker caching
   */function a(b){(0,_classCallCheck3.default)(this,a),this.redirectTo=null,this.clientCache='default',this.shouldRelayUpstreamCookies=!0,this.sent=!1,this.JSON='application/json',this.HTML='text/html',this.headers={},this.cache={browserMaxAge:0,serverMaxAge:0/**
   * Cookies to set
   */},this.cookies=[],this.request=b;var c=global.headers||{statusCode:200,statusText:'OK'};this.statusCode=+c.statusCode,this.statusText=c.statusText}/**
   * Sends response content
   * @param {String} body The body of the response
   * @return {Response} this
   *//**
   * Response headers to send
   *//**
   * The application/json mime type
   *//**
   * Set to false to prevent set-cookie headers returned from the upstream (proxied) site from
   * being relayed to the browser
   *//**
   * When set, this determines the value of the location header
   */return(0,_createClass3.default)(a,[{key:'send',value:function b(a){return this._doRelayUpstreamCookies(),global.fns.export('MOOV_PWA_RESPONSE',{statusCode:this.statusCode,statusText:this.statusText,redirectTo:this.redirectTo,headers:this.headers,cookies:this.cookies,cache:this.cache}),this.request.sendResponse({body:a,htmlparsed:null!=a}),this.sent=!0,this}/**
   * Sends JSON data
   * @param {Object} body Data
   * @return {Response} this
   */},{key:'json',value:function b(a){return this.set('content-type',this.JSON).send(JSON.stringify(a))}/**
   * Configure whether or not set-cookie headers from upstream should be sent down to the browser
   * @param {Boolean} shouldRelay True to relay upstream set-cookie headers to the browser, false to not
   */},{key:'relayUpstreamCookies',value:function b(a){return this.shouldRelayUpstreamCookies=a,this}/**
   * Relays all set-cookie headers received from fetch requests back to the browser, 
   * translating each to the current domain.
   * @private
   */},{key:'_doRelayUpstreamCookies',value:function j(){var a=env.MUR_SET_COOKIES;if(this.shouldRelayUpstreamCookies&&a)for(var k in a){var b=!0,c=!1,d=void 0;try{for(var e,f,g=a[k][Symbol.iterator]();!(b=(e=g.next()).done);b=!0){f=e.value,f=f.replace(/Domain=[^;]*(;\s*|\s*$)/gi,'');var h=injectDomain(f,k),i=injectDomain(f,this.request.hostname);this.cookies.push(h),i!==h&&this.cookies.push(f)}}catch(a){c=!0,d=a}finally{try{!b&&g.return&&g.return()}finally{if(c)throw d}}}}/**
   * Sets a response header
   * @param {String} name
   * @param {String} value
   * @return {Response} this
   */},{key:'set',value:function c(a,b){if(a.match(/set-cookie/i)&&!env.shouldSendCookies&&console.warn('[react-storefront response]','Cannot set cookies on cached route'),null==a)throw new Error('name cannot be null in call to response.set');return this.headers[a]=b,this}/**
   * Gets the value of a header by name (case insensitive)
   * @param {String} name 
   * @return {String} The header value
   */},{key:'get',value:function b(a){return this.headers[a.toLowerCase()]}/**
   * Sets the response status
   * @param {String} code 
   * @param {String} text 
   * @return {Response} this
   */},{key:'status',value:function c(a,b){return this.statusCode=a,this.statusText=b,this}/**
   * Controls caching in the service worker
   * @param {Boolean} shouldCache Set to true to cache the response on the client
   * @return {Response} this
   */},{key:'cacheOnClient',value:function b(a){if(null==a)throw new Error('shouldCache cannot be null in call to response.cacheOnClient');return this.clientCache=a?'force-cache':'default',this}/**
   * Caches the response on the server
   * @param {Number} maxAgeSeconds The time the entry should live in the cache in seconds
   * @return {Response} this
   */},{key:'cacheOnServer',value:function b(a){if(null==a)throw new Error('maxAgeSeconds cannot be null in call to response.cacheOnServer');return this.cache={serverMaxAge:a,browserMaxAge:0},this}/**
   * Sends a redirect to the specified URL
   * @param {String} url A url
   * @param {Number} status The http status code to send
   * @return {Response} this
   */},{key:'redirect',value:function c(a){var b=1<arguments.length&&void 0!==arguments[1]?arguments[1]:301;if(null==a)throw new Error('url cannot be null in call to response.redirect');return this.redirectTo=a,this.statusCode=b,this.send(),this}/**
   * Sets cookie name to value.
   * @param  {String} name  
   * @param  {String} value
   * @param  {Object} options
   * @return {Response} this      
   */},{key:'cookie',value:function e(a,b,c){var d=_cookie2.default.parse(this.headers['set-cookie']||'');// Restructure for easier serialization
return Object.keys(d).forEach(function(a){return d[a]=a+'='+d[a]}),d[a]=_cookie2.default.serialize(a,b,c),this.set('set-cookie',Object.keys(d).map(function(a){return d[a]}).join(';')),this}}]),a}();/**
 * Represents the response sent back from fromServer handlers.  Use this class to set headers, status,
 * and other response metadata.
 *//**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 *//**
 * Injects a domain into a set-cookie header
 * @param {String} cookie 
 * @param {String} domain
 * @return {String} 
 */exports.default=Response;function injectDomain(a,b){var c=a.indexOf(';')+1;return a.substr(0,c)+' Domain='+b+'; '+a.substr(c).trim()}
//# sourceMappingURL=Response.js.map