'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.default=void 0;var _asyncGenerator2=require('babel-runtime/helpers/asyncGenerator'),_asyncGenerator3=_interopRequireDefault(_asyncGenerator2),_extends2=require('babel-runtime/helpers/extends'),_extends3=_interopRequireDefault(_extends2),_objectWithoutProperties2=require('babel-runtime/helpers/objectWithoutProperties'),_objectWithoutProperties3=_interopRequireDefault(_objectWithoutProperties2),_regenerator=require('babel-runtime/regenerator'),_regenerator2=_interopRequireDefault(_regenerator),_asyncIterator2=require('babel-runtime/helpers/asyncIterator'),_asyncIterator3=_interopRequireDefault(_asyncIterator2),_asyncToGenerator2=require('babel-runtime/helpers/asyncToGenerator'),_asyncToGenerator3=_interopRequireDefault(_asyncToGenerator2),_classCallCheck2=require('babel-runtime/helpers/classCallCheck'),_classCallCheck3=_interopRequireDefault(_classCallCheck2),_createClass2=require('babel-runtime/helpers/createClass'),_createClass3=_interopRequireDefault(_createClass2),_possibleConstructorReturn2=require('babel-runtime/helpers/possibleConstructorReturn'),_possibleConstructorReturn3=_interopRequireDefault(_possibleConstructorReturn2),_inherits2=require('babel-runtime/helpers/inherits'),_inherits3=_interopRequireDefault(_inherits2),_routeParser=require('route-parser'),_routeParser2=_interopRequireDefault(_routeParser),_isFunction=require('lodash/isFunction'),_isFunction2=_interopRequireDefault(_isFunction),_qs=require('qs'),_qs2=_interopRequireDefault(_qs),_merge=require('lodash/merge'),_merge2=_interopRequireDefault(_merge),_cloneDeep=require('lodash/cloneDeep'),_cloneDeep2=_interopRequireDefault(_cloneDeep),_serviceWorker=require('./serviceWorker'),_parseMultipartRequest=require('./parseMultipartRequest'),_parseMultipartRequest2=_interopRequireDefault(_parseMultipartRequest),_Response=require('./Response'),_Response2=_interopRequireDefault(_Response),_eventemitter=require('eventemitter3'),_eventemitter2=_interopRequireDefault(_eventemitter);function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}/**
 * Provides routing for MUR-based applications and PWAs.  This class is inspired by express and uses https://github.com/rcs/route-parser,
 * which supports sophisticated pattern matching including optional paths, params, and splatting.
 *
 * Example:
 *
 *  const router = new Router()
 *
 *  router.get('/products/:id', ({ id }) => {
 *    // fetch product from upstream API (you'll need to write this function)
 *    return fetchProduct(id).then(result => {
 *      return result.product // this will be the result of router.run()
 *    })
 *  })
 *
 *  // assuming env.path = /products/1 and env.method = 'GET'
 *  router.run() // => the details for product 1
 *
 * Routes can be divided into multiple files to increase maintainability using the "use()" method.  For example:
 *
 *  // /scripts/api/router.js
 *
 *  const appShell = require('/build/index.html.js)
 *
 *  module.exports = new Router()
 *    .fallback(() => appShell) // render the PWA's app shell for all unmatched routes
 *    .use('/products', require('/api/products.js'))
 *
 *
 *  // /scripts/api/products.js
 *
 *  module.exports = new Router()
 *    .get('/:id', ({ id }) => new Promise((resolve, reject) => {
 *      // fetch product from upstream API...
 *     }))
 *
 *
 *  // /scripts/index.js
 *
 *  const router = require('/api/router')
 *
 *  module.exports = function() {
 *    // ...
 *    router.run().then((result) => {
 *      const body = typeof result === 'string' ? result : JSON.stringify(result)
 *      sendResponse({ body, htmlparsed: true })
 *    })
 *  }
 * 
 * Router is an EventEmitting that fires the following events:
 * 
 * `before`: Fires before a route is run, passing an object containing `request` and `response`.
 * `after`: Fires after a route is run and all handlers have finised, passing an object containing `request` and `response`.
 * `fetch`: Fires when a `fromServer` handler runs on the client, resulting in a fetch from the server. No arguments are passed to the event handler.
 */var Router=function(a){function b(){var a=this;(0,_classCallCheck3.default)(this,b);var c=(0,_possibleConstructorReturn3.default)(this,(b.__proto__||Object.getPrototypeOf(b)).call(this));return c.onLocationChange=function(){var b=(0,_asyncToGenerator3.default)(/*#__PURE__*/_regenerator2.default.mark(function b(d,e,f){var g,h,i,j,k,l,m,n,o,p,q,r;return _regenerator2.default.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:if('REPLACE'!==f){a.next=2;break}return a.abrupt('return');case 2:if(e.pathname!==c.prevLocation.pathname||e.search!==c.prevLocation.search){a.next=4;break}return a.abrupt('return');case 4:if(c.prevLocation=e,g=e.pathname,h=e.search,i={pathname:g,search:h,method:'GET'},j=new _Response2.default(i),k=e.state,k&&d(k,f),c.emit('before',{request:i,response:j}),'PUSH'!==f&&k){a.next=48;break}l=!0,m=!1,n=void 0,a.prev=15,o=(0,_asyncIterator3.default)(c.run(i,j,{historyState:k}));case 17:return a.next=19,o.next();case 19:return p=a.sent,l=p.done,a.next=23,p.value;case 23:if(q=a.sent,l){a.next=30;break}r=q,d(r,f);case 27:l=!0,a.next=17;break;case 30:a.next=36;break;case 32:a.prev=32,a.t0=a['catch'](15),m=!0,n=a.t0;case 36:if(a.prev=36,a.prev=37,l||!o.return){a.next=41;break}return a.next=41,o.return();case 41:if(a.prev=41,!m){a.next=44;break}throw n;case 44:return a.finish(41);case 45:return a.finish(36);case 46:a.next=49;break;case 48:k&&d(k,f);case 49:c.emit('after',{request:i,response:j});case 50:case'end':return a.stop();}},b,a,[[15,32,36,46],[37,,41,45]])}));return function(){return b.apply(this,arguments)}}(),c.routes=[],c.isBrowser='client'===process.env.MOOV_RUNTIME,c.fallbackHandlers=[{runOn:{client:!0,server:!0},fn:function a(){return{page:'404'}}}],c.errorHandler=function(a,b,d,e){return console.error('Error caught with params',b,' and with message:',a.message),c.isBrowser||e.status(500,'error'),{page:'Error',error:a.message,stack:a.stack,loading:!1}},c}return(0,_inherits3.default)(b,a),(0,_createClass3.default)(b,[{key:'pushRoute',value:function d(a,b,c){return this.routes.push({path:new _routeParser2.default(b+'.:format'),method:a,handlers:c}),this.routes.push({path:new _routeParser2.default(b),method:a,handlers:c}),this}/**
   * Registers a GET route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:'get',value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute('GET',a,c)}/**
   * Registers a POST route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:'post',value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute('POST',a,c)}/**
   * Registers a PATCH route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:'patch',value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute('PATCH',a,c)}/**
   * Registers a PUT route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:'put',value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute('PUT',a,c)}/**
   * Registers a DELETE route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:'delete',value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute('DELETE',a,c)}/**
   * Registers an OPTIONS route
   * @param {String} path A path pattern
   * @param {Function} callback A function that is passed the params as an object and returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:'options',value:function e(a){for(var b=arguments.length,c=Array(1<b?b-1:0),d=1;d<b;d++)c[d-1]=arguments[d];return this.pushRoute('OPTIONS',a,c)}/**
   * Designates the handlers for unmatched routes
   * @param {Function} callback A function that returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:'fallback',value:function d(){for(var a=arguments.length,b=Array(a),c=0;c<a;c++)b[c]=arguments[c];return this.fallbackHandlers=b,this}/**
   * Sets the handler for errors thrown during route handling
   * @param {Function} handler A function that returns a promise that resolves to the content to return
   * @return {Router} this
   */},{key:'error',value:function b(a){return this.errorHandler=a,this}/**
   * Registers a set of nested routes.
   *
   * Example:
   *
   *  Router root = new Router()
   *
   *  Router products = new Router()
   *  products.get('/:id', ({ id }) => {
   *    return Promise.resolve(id)
   *  })
   *
   *  root.use('/products', products)
   *
   *  // url: /products/1
   *  root.run().then(result => console.log(result)) // => 1
   *
   * @param {String} path The parent path
   * @param {Router} router A router to handle the nested routes
   * @return {Router} this
   */},{key:'use',value:function k(a,b){var c=!0,d=!1,e=void 0;try{for(var f,g=b.routes[Symbol.iterator]();!(c=(f=g.next()).done);c=!0){var h=f.value,i=h.path,j=(0,_objectWithoutProperties3.default)(h,['path']);this.routes.push((0,_extends3.default)({path:new _routeParser2.default(a+i.spec)},j))}}catch(a){d=!0,e=a}finally{try{!c&&g.return&&g.return()}finally{if(d)throw e}}return this}/**
   * @private
   * Caches the initialState (json) and HTML using the service worker.
   * @param {Object} request
   */},{key:'cacheInitialState',value:function d(a){var b=a.pathname,c=a.search;(0,_serviceWorker.cache)(b+c,'<!DOCTYPE html>\n'+document.documentElement.outerHTML)}/**
   * Configures service worker runtime caching options
   * @param {Object} options
   * @param {Object} options.cacheName The name of the runtime cache
   * @param {Object} options.maxEntries The max number of entries to store in the cache
   * @param {Object} options.maxAgeSeconds The TTL in seconds for entries
   * @return {Router} this
   */},{key:'configureClientCache',value:function b(a){return(0,_serviceWorker.configureCache)(a),this}/**
   * Gets the server cache key for the matching route.
   * @param {Object} request
   * @param {Object} defaults The default values used for the cache key
   * @return {Object} An object populate with keys and values that when hashed, make up the cache key
   */},{key:'getCacheKey',value:function g(a,b){var c=this.findMatchingRoute(a),d=c.match,e=d?d.handlers:this.fallbackHandlers;if(!e)return b;var f=e.find(function(a){return'cache'===a.type});return f&&f.server&&f.server.key?f.server.key(a,b):b}/**
   * Creates an object describing the browser location
   * @return {Object}
   */},{key:'createLocation',value:function a(){return{protocol:location.protocol.replace(/:/,''),pathname:location.pathname,search:location.search,hostname:location.hostname,port:location.port}}/**
   * Runs the current url (from env) and generates a result from each the matching route's handlers.
   * @param {Object} request The request being served
   * @param {String} request.path The url path
   * @param {String} request.method The http method
   * @param {Response} response The response object
   * @param {Object} options
   * @param {Boolean} [options.initialLoad=false] Set to true if this is the initial load of the application.  This will cause the HTML to be cached for the current path
   * @return {Object} Generates state objects
   */},{key:'run',value:function(){var a=_asyncGenerator3.default.wrap(/*#__PURE__*/_regenerator2.default.mark(function a(b,c){var d,e,f,g,h,i,j,k,l,m,n,o,p=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},q=p.initialLoad,r=void 0!==q&&q,s=p.historyState,t=void 0===s?{}:s;return _regenerator2.default.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:if(d=this.findMatchingRoute(b),e=d.match,f=d.params,b.params=f,g=e?e.handlers:this.fallbackHandlers,h=!r&&g.some(function(a){return'fromServer'===a.type}),!this.isBrowser){a.next=9;break}return a.next=7,(0,_extends3.default)({loading:h,location:this.createLocation()},t);case 7:a.next=10;break;case 9:this.parseBody(b);case 10:a.prev=10,i=!0,j=!1,k=void 0,a.prev=14,l=g[Symbol.iterator]();case 16:if(i=(m=l.next()).done){a.next=37;break}if(n=m.value,'function'==typeof n&&(n={runOn:{server:!0,client:!0},fn:n}),!(r&&'cache'!==n.type)){a.next=21;break}return a.abrupt('continue',34);case 21:if(n.runOn.client||!this.isBrowser){a.next=23;break}return a.abrupt('continue',34);case 23:if(n.runOn.server||this.isBrowser){a.next=25;break}return a.abrupt('continue',34);case 25:if(!(b.pathname.endsWith('.json')&&(!0!==n.runOn.server||this.isBrowser))){a.next=27;break}return a.abrupt('continue',34);case 27:return'fromServer'===n.type&&this.emit('fetch'),a.next=30,_asyncGenerator3.default.await(this.toPromise(n.fn,f,b,c));case 30:if(o=a.sent,!o){a.next=34;break}return a.next=34,o;case 34:i=!0,a.next=16;break;case 37:a.next=43;break;case 39:a.prev=39,a.t0=a['catch'](14),j=!0,k=a.t0;case 43:a.prev=43,a.prev=44,!i&&l.return&&l.return();case 46:if(a.prev=46,!j){a.next=49;break}throw k;case 49:return a.finish(46);case 50:return a.finish(43);case 51:r&&'force-cache'===c.clientCache&&this.cacheInitialState(b,c),a.next=58;break;case 54:return a.prev=54,a.t1=a['catch'](10),a.next=58,this.errorHandler(a.t1,f,b,c);case 58:case'end':return a.stop();}},a,this,[[10,54],[14,39,43,51],[44,,46,50]])}));return function b(){return a.apply(this,arguments)}}()/**
   * Runs all client and server handlers for the specified path and method
   * @param {Object} request The request being served
   * @param {String} request.path The url path
   * @param {String} request.method The http method
   * @param {Response} response The response object
   * @param {Object} options
   * @param {Object} [state={}] The accumulated state from other handlers
   * @return {Object} The merged result of all handlers
   */},{key:'runAll',value:function(){var a=(0,_asyncToGenerator3.default)(/*#__PURE__*/_regenerator2.default.mark(function a(b,c,d){var e,f,g,h,i,j,k,l=3<arguments.length&&void 0!==arguments[3]?arguments[3]:{};return _regenerator2.default.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:l=(0,_cloneDeep2.default)(l),e=!0,f=!1,g=void 0,a.prev=4,h=(0,_asyncIterator3.default)(this.run(b,c,d));case 6:return a.next=8,h.next();case 8:return i=a.sent,e=i.done,a.next=12,i.value;case 12:if(j=a.sent,e){a.next=19;break}k=j,'string'==typeof k?l=k:(0,_merge2.default)(l,k);case 16:e=!0,a.next=6;break;case 19:a.next=25;break;case 21:a.prev=21,a.t0=a['catch'](4),f=!0,g=a.t0;case 25:if(a.prev=25,a.prev=26,e||!h.return){a.next=30;break}return a.next=30,h.return();case 30:if(a.prev=30,!f){a.next=33;break}throw g;case 33:return a.finish(30);case 34:return a.finish(25);case 35:return a.abrupt('return',l);case 36:case'end':return a.stop();}},a,this,[[4,21,25,35],[26,,30,34]])}));return function b(){return a.apply(this,arguments)}}()/**
   * Parses JSON and form body content
   * @private
   * @param {String} body The request body
   * @param {String} contentType The content-type header
   * @return {Object}
   */},{key:'parseBody',value:function d(a){if(a.headers&&a.body){var b=(a.headers['content-type']||'').toLowerCase(),c=a.body;if('application/json'===b)try{a.body=JSON.parse(c)}catch(a){throw new Error('could not parse request body as application/json: '+a.message)}else if('application/x-www-form-urlencoded'===b)try{a.body=_qs2.default.parse(c)}catch(a){throw new Error('could not parse request body as x-www-form-urlencoded: '+a.message)}else if(b.startsWith('multipart/form-data'))try{a.body=(0,_parseMultipartRequest2.default)(a)}catch(a){throw new Error('could not parse request body as multipart/form-data: '+a.message)}}}/**
   * Converts specified callback to a promise
   * @param {Function/Object} callback A function that returns a Promise that
   *  resolves to the new state, a function that returns the new state, or the new state itself.
   * @param {Object} params The request parameters
   * @param {Object} request The request object with body and headers
   * @param {Response} response The response object
   */},{key:'toPromise',value:function e(a,b,c,d){if((0,_isFunction2.default)(a)){var f=a(b,c,d);return f&&f.then?f:Promise.resolve(f)}// callback is the new state
return Promise.resolve(a)}/**
   * Returns the matching route and parsed params for the specified path and method
   * @param {Object} request The http request
   * @return {Object} an object with match and params
   */},{key:'findMatchingRoute',value:function h(a){var b=void 0,c=a.pathname,d=a.search,e=a.method,f=void 0===e?'GET':e;f=f.toUpperCase();var g=this.routes.filter(function(a){return f===a.method}).find(function(a){return b=a.path.match(c+d)});return{match:g,params:(0,_extends3.default)({},b,_qs2.default.parse(d,{ignoreQueryPrefix:!0}))}}/**
   * Returns true if the URL points to a route that has a proxyUpstream handler.  
   * @param {String} url The url to check
   * @param {String} [method='get']
   * @return {Boolean}
   */},{key:'willNavigateToUpstream',value:function f(a){var b=1<arguments.length&&void 0!==arguments[1]?arguments[1]:'get',c=new URL(a,'undefined'==typeof window?void 0:window.location),d=c.pathname,e=c.search;return this.willFetchFromUpstream({pathname:d,search:e,method:b})}/**
   * Returns true if the route will result in the server connecting to the
   * upstream site due to the presence of a `proxyUpstream` handler, otherwise
   * false.
   * @private
   * @param {Object} request
   * @return {Boolean}
   */},{key:'willFetchFromUpstream',value:function e(a){var b=this.findMatchingRoute(a),c=b.match,d=c?c.handlers:this.fallbackHandlers;return d.some(function(a){return'proxyUpstream'===a.type})}/**
   * Called when the location is changed on the client
   * @param {Function} callback A callback to pass the new state to
   * @param {Object} location The new location
   */},{key:'watch',/**
   * Calls the specified callback whenever the current URL changes
   * @param {History} history
   * @param {Function} callback
   * @return {Router} this
   */value:function h(a,b){this.history=a,this.prevLocation=a.location,a.listen(this.onLocationChange.bind(this,b));var c=a.location,d=c.pathname,e=c.search,f={pathname:d,search:e,method:'GET'},g=new _Response2.default(f);return this.runAll(f,g,{initialLoad:!0},window.initialState),this.emit('after',{request:f,response:g,initialLoad:!0}),this}/**
   * Provides an easy way to navigate by changing some but not all of the query params.  Any keys
   * included in the params object are applied as new query param values.  All other query params are preserved.
   * @param {Object} params Key/value pairs to apply to the query string.  Specifying a value of undefined or null will remove that parameter from the query string
   */},{key:'applySearch',value:function d(a){var b=this.history,c=_qs2.default.stringify((0,_extends3.default)({},_qs2.default.parse(b.location.search,{ignoreQueryPrefix:!0}),a));b.replace(b.location.pathname+'?'+c)}/**
   * Gets the query string parameters for the current url as an object of key/value pairs
   * @return {Object}
   */},{key:'getQueryParams',value:function b(){var a=this.history;return _qs2.default.parse(a.location.search,{ignoreQueryPrefix:!0})}}]),b}(_eventemitter2.default);/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */exports.default=Router;
//# sourceMappingURL=Router.js.map