'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.default=cache;/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 *//**
 * Specifies that the result of a route should be cached.  This handler must come before fromServer.
 * 
 * Example:
 *  
 *    router.get('/p/:id', 
 *      cache({ 
 *        server: {
 *          maxAgeSeconds: 300 // cache for 5 minutes on the server,
 *          key: (request, defaults) => ({ // cache result separately for mobile and desktop user agents
 *            ...defaults,
 *            mobile: ['iOS', 'Android'].includes(
 *              new UAParser(request.headers['user-agent']).getOS().name
 *            )
 *          })
 *        }, 
 *        client: true // cache in the service worker based on the settings passed to router.configureClientCache()
 *      }) 
 *      fromClient({ view: 'Product' }),
 *      fromServer('./product.js'),
 *    )
 * 
 * @param {Object} options
 * @param {Number} options.server 
 * @param {Number} options.server.maxAgeSeconds The number of seconds the result should be cached on the server.  The maxAgeSeconds key is required when specifying a server config.
 * @param {Function} options.server.key A function to compute a custom cache key for server-side caching.  The function is
 *  passed the request object and a defaults object containing the key/value pairs that make up the default cache key.  This function is optional when specifying a server config.
 * @param {Boolean} options.client Set to true to cache on the client based on the configuration defined by router.configureClientCache(). Defaults to false.
 * @return {Object}
 */function cache(a){var b=a.server,c=a.client;return{type:'cache',client:c,server:b,runOn:{server:!0,client:!0},fn:function f(a,d,e){if('server'===process.env.MOOV_RUNTIME&&'development'===process.env.MOOV_ENV&&'get'!==d.method.toLowerCase())throw new Error('Invalid use of cache handler for '+d.method+' request. Only GET requests can be cached.');'client'===process.env.MOOV_RUNTIME?c&&e.cacheOnClient(!0):b&&b.maxAgeSeconds&&(env.shouldSendCookies=!1,e.relayUpstreamCookies(!1),e.cacheOnServer(b.maxAgeSeconds))}}}
//# sourceMappingURL=cache.js.map