'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.fetch=void 0;var _regenerator=require('babel-runtime/regenerator'),_regenerator2=_interopRequireDefault(_regenerator),_extends2=require('babel-runtime/helpers/extends'),_extends3=_interopRequireDefault(_extends2),_asyncToGenerator2=require('babel-runtime/helpers/asyncToGenerator'),_asyncToGenerator3=_interopRequireDefault(_asyncToGenerator2),fetch=exports.fetch=function(){var a=(0,_asyncToGenerator3.default)(/*#__PURE__*/_regenerator2.default.mark(function a(b){var c,d,e,f,g=1<arguments.length&&arguments[1]!==void 0?arguments[1]:{},h=g.cache,i=h===void 0?'default':h;return _regenerator2.default.wrap(function(a){for(;;)switch(a.prev=a.next){case 0:return(0,_serviceWorker.abortPrefetches)(),doFetch=doFetch||(0,_fetchLatest.fetchLatest)(require('isomorphic-unfetch')),c=location,d=c.href,a.prev=3,e=(window.moov||{}).apiVersion,a.next=7,doFetch(b,{cache:i||'default',credentials:'include',headers:{"x-react-storefront":'true',// allows back end handlers to quickly identify PWA API requests,
"x-moov-api-version":e// needed for the service worker to determine the correct runtime cache name and ensure that we're not getting a cached response from a previous api version
}}).then(function(a){var b=a.redirected,c=a.url;return b?void redirectTo(c):((0,_serviceWorker.resumePrefetches)(),a.json())});case 7:if(f=a.sent,null==f||location.href!==d){a.next=10;break}return a.abrupt('return',(0,_extends3.default)({loading:!1},f));case 10:a.next=19;break;case 12:if(a.prev=12,a.t0=a['catch'](3),!_fetchLatest.StaleResponseError.is(a.t0)){a.next=18;break}return a.abrupt('return',null);case 18:throw a.t0;case 19:case'end':return a.stop();}},a,this,[[3,12]])}));return function(){return a.apply(this,arguments)}}();/**
 * Fetch's state as json from the specified url
 * @param {String} url The url to fetch
 * @param {Object} options 
 * @param {String} options.cache Set to "force-cache" to cache the response in the service worker.  Omit to skip the service worker cache.
 * @return {Object} A state patch
 *//**
 * Handles a redirect response.  Will do a client side navigation if the URL has the same hostname as the app, otherwise will
 * reload the page.
 * @param {String} url 
 */exports.default=fromServer;var _fetchLatest=require('../fetchLatest'),_serviceWorker=require('./serviceWorker');function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */var doFetch=void 0;function redirectTo(a){if(a){var b=new URL(a),c=window.moov.history;b.hostname===window.location.hostname?c.push(b.pathname+b.search):window.location.assign(a)}else throw new Error('Received a redirect without a location header.')}/**
 * Creates a handler that fetches data from the server.
 * 
 * The `handlerPath` should point to a module that exports a function that takes params, request, and response, 
 * and returns an object that should be applied to the app state.  For example:
 * 
 *  // routes.js
 *  router.get('/p/:id'
 *    fromServer('./product/product-handler')
 *  )
 * 
 *  // product/product-handler.js
 *  export default function productHandler(params, request, response) {
 *    return fetchFromUpstreamApi(`/products/${params.id}`)
 *      .then(res => res.json())
 *      .then(productData => ({ // the shape of this object should match your AppModel
 *        page: 'Product',
 *        product: productData
 *      }))
 *  }
 * 
 * When the request path ends in ".json", the json response will be returned verbatim.  In all other cases, server-side rendered HTML
 * will be returned.
 * 
 * You can also send a verbatim string response using `response.send(body)`.  For example:
 * 
 *  // routes.js
 *  router.get('/my-api'
 *    fromServer('./my-api-handler')
 *  )
 * 
 *  // my-api-handler.js
 *  export default function myApiHandler(params, request, response) {
 *    response
 *      .set('content-type', response.JSON)
 *      .send(JSON.stringify({ foo: 'bar' }))
 *  }
 * 
 * When `response.send()` is called in a handler, react-storefront will never perform server-side rendering.
 * 
 * @param {String} handlerPath The path to the module that exports a handler function that returns state to apply
 * @param {Function} getURL An optional function that returns the back end url to call when fetching.  You only need 
 *   to specify this if you want to override the default URL.
 * @return {Function}
 */function fromServer(a,b){return{type:'fromServer',runOn:{server:!0,client:!0// fromServer handlers run on the client too - we make an ajax request to get the state from the server
},fn:function(){var c=(0,_asyncToGenerator3.default)(/*#__PURE__*/_regenerator2.default.mark(function c(d,e,f){var g;return _regenerator2.default.wrap(function(c){for(;;)switch(c.prev=c.next){case 0:if('string'!=typeof a){c.next=6;break}return g=location.pathname+'.json'+location.search,b&&(g=b(g)),c.abrupt('return',fetch(g,{cache:f.clientCache}));case 6:if(null!=a){c.next=8;break}throw new Error('You must provide a path to a handler in fromServer().  Please check your routes.');case 8:return f.set('x-rsf-handler',a.path),f.set('x-rsf-response-type',e.path.endsWith('.json')?'json':'ssr'),c.abrupt('return',a(d,e,f));case 11:case'end':return c.stop();}},c,this)}));return function a(){return c.apply(this,arguments)}}()}}
//# sourceMappingURL=fromServer.js.map