'use strict';Object.defineProperty(exports,'__esModule',{value:!0});var _toConsumableArray2=require('babel-runtime/helpers/toConsumableArray'),_toConsumableArray3=_interopRequireDefault(_toConsumableArray2);exports.injectScriptInHead=injectScriptInHead,exports.injectCodeInHead=injectCodeInHead,exports.removeScriptInHead=removeScriptInHead,exports.removeCodeInHead=removeCodeInHead;function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 *//**
 * Method for checking script tag in <head>
 * @param {String} src path to script
 */function isScriptInjected(a){if('undefined'==typeof document)return!1;var b=[].concat((0,_toConsumableArray3.default)(document.querySelectorAll('script[src^="'+a+'"]')));return 0<b.length}/**
 * Method for checking script tag in <head>
 * @param {String} code script code
 */function isCodeInjected(a){if('undefined'==typeof document)return!1;var b=[].concat((0,_toConsumableArray3.default)(document.head.getElementsByTagName('script'))).filter(function(b){return b.innerHTML===a});return 0<b.length}/**
 * Method for injecting script tag in <head>
 * @param {String} src path to script
 * @param {Object} [params] Optional params
 * @param {Object} [params.attrs={}] Optional attributes to add to element
 * @param {Boolean} [params.once=true] If true then script will be injected only once
 * @returns {Promise} Promise returns on script's onload event
 */function injectScriptInHead(a){var b=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},c=b.attrs,d=void 0===c?{}:c,e=b.once;if((void 0===e||e)&&isScriptInjected(a))return Promise.resolve();if('undefined'==typeof document)return Promise.resolve();var f=void 0,g=document.createElement('script');return g.src=a,Object.keys(d).forEach(function(a){g.setAttribute(a,d[a])}),f=new Promise(function(a,b){g.onload=a,g.onerror=b}),document.head.appendChild(g),f}/**
 * Method for injecting target code in <head>
 * @param {String} code script code
 * @param {Object} [params] optional params
 * @param {Boolean} [params.once=false] If true then script will be injected only once
 */function injectCodeInHead(a){var b=1<arguments.length&&arguments[1]!==void 0?arguments[1]:{},c=b.once;if(!((!(c!==void 0)||c)&&isCodeInjected(a))&&'undefined'!=typeof document){var d=document.createElement('script');d.appendChild(document.createTextNode(a)),document.head.appendChild(d)}}/**
 * Method for removing script in <head>
 * @param {String} src path to script
*/function removeScriptInHead(a){[].concat((0,_toConsumableArray3.default)(document.querySelectorAll('script[src^="'+a+'"]'))).forEach(function(a){return a.parentNode.removeChild(a)})}/**
 * Method for removing code  in <head>
 * @param {String} code script code
*/function removeCodeInHead(a){[].concat((0,_toConsumableArray3.default)(document.head.getElementsByTagName('script'))).filter(function(b){return b.innerHTML===a}).forEach(function(a){return a.parentNode.removeChild(a)})}var scriptInjector={injectScriptInHead:injectScriptInHead,injectCodeInHead:injectCodeInHead,removeScriptInHead:removeScriptInHead,removeCodeInHead:removeCodeInHead};exports.default=scriptInjector;
//# sourceMappingURL=scriptInjector.js.map