'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.relativeURL=relativeURL,exports.absoluteURL=absoluteURL,exports.canUseClientSideNavigation=canUseClientSideNavigation;/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 *//**
 * Strips the protocol and hostname from the URL, returning a relative URL.
 * @param {String} url An absolute or relative URL 
 * @return {String} A relative URL
 */function relativeURL(a){return null==a?null:(a=a.replace(/^(https?:)?\/\/[^\/]*/,''),0===a.length&&(a='/'),a)}var cleanProtocol=function(a){return(a||'').replace(/:/,'')};/**
 * Creates an absolute URL for the given URL
 * @param {String} url A relative URL
 * @param {LocationModel} currentLocation The current browser location
 * @return {String} An absolute URL
 */function absoluteURL(a,b){if(null==a)return null;if(null==b)return a;if(a.match(/^(mailto|tel):/))return a;if(a.match(/^\/\//))// URL with hostname but no protocol (starting with //)
return cleanProtocol(b.protocol)+':'+a;if(!a.match(/^https?:/)){a.match(/^\//)||(a=b.pathname+'/'+a);var c=b.port;return c='80'===c||'443'===c?'':':'+c,cleanProtocol(b.protocol)+'://'+b.hostname+c+a}return a}/**
 * Returns true if a URL can be navigated to on the client using history.push
 * @param {String} url The URL to check
 * @param {String} router The router 
 * @return {Boolean}
 */function canUseClientSideNavigation(a,b){// return false for hash links
// check if there is a proxyUpstream handler on the corresponding route
return!!a&&!a.match(/^(mailto|tel):/)&&!a.match(/^#/)&&!a.match(/^(http|https)?:?\/\//)&&!(b&&b.willNavigateToUpstream(a));// return false for non-webpage links
// return false for absolute URLs
}
//# sourceMappingURL=url.js.map